package dev.urmomia.systems.commands.commands;

import com.mojang.brigadier.builder.LiteralArgumentBuilder;
import dev.urmomia.systems.commands.Command;
import dev.urmomia.utils.player.ChatUtils;
import net.minecraft.client.network.ServerInfo;
import net.minecraft.command.CommandSource;
import net.minecraft.nbt.CompoundTag;
import net.minecraft.server.integrated.IntegratedServer;
import net.minecraft.text.BaseText;
import net.minecraft.text.LiteralText;

import static com.mojang.brigadier.Command.SINGLE_SUCCESS;

public class ServerCommand extends Command {

    public ServerCommand() {
        super("server", "Prints server information");
    }

    @Override
    public void build(LiteralArgumentBuilder<CommandSource> builder) {
        builder.executes(context -> {
            if(mc.isIntegratedServerRunning()) {
                IntegratedServer server = mc.getServer();
                info("Singleplayer");
                if (server != null) {
                    info( "Version: %s", server.getVersion());
                }
                return SINGLE_SUCCESS;
            }
            ServerInfo server = mc.getCurrentServerEntry();

            if (server == null) {
                error("Couldn't obtain any server information.");
                return SINGLE_SUCCESS;
            }

            info("IP: %s", server.address);
            String serverType = mc.player.getServerBrand();
            if (serverType == null) {
                serverType = "unknown";
            }
            info("Type: %s", serverType);

            BaseText motd = new LiteralText("Motd: ");
            if (server.label != null) {
                motd.append(server.label);
            } else {
                motd.append(new LiteralText("unknown"));
            }

            ChatUtils.info("Server", motd);
            
            BaseText version = new LiteralText("Version: ");
            version.append(server.version);
            ChatUtils.info("Server", version);
            
            info("Protocol version: %d", server.protocolVersion);
            
            return SINGLE_SUCCESS;
        });

        builder.then(literal("gamerules").executes(ctx -> {
            CompoundTag tag = mc.world.getGameRules().toNbt();
            tag.getKeys().forEach((key) -> {
                    info( "%s: %s", key, tag.getString(key));
            });
            return SINGLE_SUCCESS;
        }));
    }
    
}